<!--宇宙课搭售实物需求 created By 1173944134@qq.com-->
<template>
    <!--加购弹窗-->
    <div class="yidialog-con real-thing-dia" id="addBuyDia">
        <div class="yid-back"></div>
        <div class="yid-con flex-row">
            <div class="yid-cls-con">
                <img src="" class="yid-cls"/>
            </div>
            <div class="yid-con-body flex-row">
                <div class="xsq-btn flex-row heart-beat"></div>
                <div class="djs-con"></div>
            </div>
        </div>
    </div>
    <!--二次确认蒙层-->
    <div class="yidialog-con real-thing-cfmdia" id="cfmBuyDia">
        <div class="yid-back"></div>
        <div class="yid-con flex-row">
            <div class="yid-con-body">
                <img src="" class="icon"/>
                <div class="jg-btn flex-row"></div>
            </div>
        </div>
    </div>
    <!--购买详情页倒计时卡片-->
    <div class="csdetail-djscon flex-row" id="csDetailDjsCon">
        <div class="djs-l flex-row">
            <div class="l">
                <div class="bi">￥</div>
                <div class="num">99.0</div>
            </div>
            <div class="r">
                <div class="r-con">
                    <div class="old-p">
                        原价：
                        <div class="old">￥138</div>
                    </div>
                    <div class="badge">限时5折抢购</div>
                </div>
            </div>
        </div>
        <div class="djs-r">
            <div>距抢购结束仅剩</div>
            <div class="djs">0:0:0:0:0</div>
        </div>
    </div>
    <!--购买详情页加购-->
    <div class="csdetail-buybtn csdetail-buyreal" id="csDetailRealBtn">
        <div class="buy-real">
            <div class="price">￥69</div>
            <div class="label">加购教具</div>
        </div>
    </div>
    <!--购买详情双购购买按钮-->
    <div class="csdetail-buybtn" id="csDetailBtn">
        <div class="flex-row hand-con icon-click">
            <img src="" class="tip"/>
            <img src="" class="icon"/>
        </div>
        <div class="buy-video flex-row">
            <div class="price">￥90</div>
            <div class="label">购买视频</div>
        </div>
        <div class="buy-real flex-row">
            <div class="price">￥99.0</div>
            <div class="label">视频+教具</div>
        </div>
    </div>
    <!--课程目录页-->
    <div class="sectionList-con" id="sectionListCon">
        <img src="" class="icon heart-beat"/>
    </div>
    <!--课程播放页浮标-->
    <div class="sectionList-icon heart-beat" id="sectionListIcon">
        <img src="" class="icon"/>
    </div>
</template>

<script>
    export default {
        /**宇宙课实物购买**/
        imgPath: resourcePath + '/imgs/groupPurchase/act/real_thing/',
        data: {
            realBuyCfm: 'real_thing_cfm', // 二次确认蒙层
            realThingDia: 'real_thing_dia', // 弹窗cookie键值
            buyType: false, // 1类用户已购买视频true，2类未购买视频false
            totalTime: 0,
            onlyVideoCourseId: 13, // 单独视频课程id
            nowPriceArr: [69.0, 99.0],
            oldPriceArr: [138, 198],
            relatedId: -1, // 课程首页和我的
            videoCourses: ['13,73'], // 视频课程
            realCourses: [77], // 实物课程
            doubleCourses: [79] // 双购课程
        },
        pvuvKey: {
            1: 'dt_btn_dengta_universe_dialog_real_goods',
            2: 'dt_btn_dengta_universe_dialog_real_goods_close_btn',
            3: 'dt_btn_dengta_universe_dialog_real_goods_confirm_btn',
            4: 'dt_btn_dengta_universe_dialog_video_and_real',
            5: 'dt_btn_dengta_universe_dialog_video_and_real_close_btn',
            6: 'dt_btn_dengta_universe_dialog_video_and_real_confirm_btn',
            7: 'dt_btn_dengta_universe_page_course_section_banner',
            8: 'dt_btn_dengta_universe_page_course_section_banner_btn',
            9: 'dt_btn_dengta_universe_page_course_section_float',
            10: 'dt_btn_dengta_universe_page_course_section_float_btn',
            11: 'dt_btn_dengta_universe_page_course_course_comfig_layer',
            12: 'dt_btn_dengta_universe_page_course_course_comfig_layer_btn'
        },
        name: 'real_thing',
        init: function () {
            (ApiHelper.courseList || ApiHelper.moreCourse) && this.initMoreCourse()
            ApiHelper.courseDetails && this.initCourseDetails()
            ApiHelper.scoreRecord && this.initScoreRecord()
            ApiHelper.sectionList && this.initSectionList()
            // ApiHelper.sectionContent && this.initSectionContent()
        },
        // 课程目录页面卡片
        initSectionList: function () {
            var that = this
            var csid = parseInt(ApiHelper.getQueryString('courseId'))
            var idx = -1
            this.data.videoCourses.forEach(function (one, i) {
                var arr = one.split(',') || []
                if (ApiHelper.idxInArr(arr, '' + csid) > -1) {
                    idx = i
                }
            })

            if (idx === -1) {
                return
            }
            that.data.relatedId = that.data.realCourses[idx]
            $.post(ApiHelper.CONFIG.realThingBuyInfo, function (res) {
                var userBuyGoodsType = (res.value || {}).userBuyGoodsType
                if (userBuyGoodsType !== 1) {
                    return
                }
                // pvuv
                ApiHelper.addPvuv({
                    btn: that.pvuvKey['7']
                })
                $(sectionListCon).insertBefore($('.containt .banner'))
                $('.containt .banner').hide()
                $('#sectionListCon').css({
                    backgroundImage: 'url("' + that.imgPath + 'yz-card.png?v=' + ApiHelper.myVer + '")'
                })
                $('#sectionListCon').click(function () {
                    // pvuv
                    ApiHelper.addPvuv({
                        btn: that.pvuvKey['8']
                    }, function () {
                        that.goCourseDetail(20072)
                    })
                })
                $('#sectionListCon .icon').attr('src', that.imgPath + 'yz-xsq.png?v=' + ApiHelper.myVer)
            })
        },
        // 课程播放页面
        initSectionContent: function () {
            var that = this
            var csid = parseInt(ApiHelper.getQueryString('courseId'))
            var idx = -1
            this.data.videoCourses.forEach(function (one, i) {
                var arr = one.split(',') || []
                if (ApiHelper.idxInArr(arr, '' + csid) > -1) {
                    idx = i
                }
            })
            if (idx === -1) {
                return
            }
            this.data.relatedId = this.data.realCourses[idx]
            $.post(ApiHelper.CONFIG.realThingBuyInfo, function (res) {
                var userBuyGoodsType = (res.value || {}).userBuyGoodsType
                if (userBuyGoodsType !== 1) {
                    return
                }
                // pvuv
                ApiHelper.addPvuv({
                    btn: that.pvuvKey['9']
                })
                $('body').append(sectionListIcon)
                setTimeout(function () {
                    $('.invite_watch_icon').hide()
                }, 0)
                $('#sectionListIcon').find('.icon').attr('src', that.imgPath + 'list_icon.png?v=' + ApiHelper.myVer)
                $('#sectionListIcon').click(function () {
                    // pvuv
                    ApiHelper.addPvuv({
                        btn: that.pvuvKey['10']
                    }, function () {
                        that.goCourseDetail(20073)
                    })
                })

                setTimeout(function () {
                    $('.invite_watch_icon').hide()
                }, 1000)
            })
        },
        // 禁止分享
        forbidfShare: function () {
            var groupBuyAppType = $('body').data('groupBuyAppType')
            var groupBuyAppId = $('body').data('groupBuyAppId')
            ApiHelper.initWXShare({
                appId: groupBuyAppId,
                appType: groupBuyAppType,
                nonce: 'myProfit',
                hideMenuList: [
                    'menuItem:share:timeline', // 分享到朋友圈
                    "menuItem:share:appMessage",
                    "menuItem:share:qq",
                    "menuItem:share:weiboApp",
                    'menuItem:share:QZone',
                    'menuItem:copyUrl',
                    'menuItem:openWithQQBrowser',
                    'menuItem:openWithSafari'
                ]
            });
        },
        // 学分记录礼品订单
        initScoreRecord: function () {
            $('body').on('getGoodsList', function () {
                $('.gift_item[data-type=1]').each(function (i, one) {
                    $(this).find('.date .text').text('订单时间: ')
                    $(this).find('.score .star').text('合计:').css({
                        width: 'auto'
                    })
                    var num = $(this).find('.score .num').text() * 1 / 100
                    $(this).find('.score .num').text('￥' + num)
                })
            })
        },
        // 课程详情页
        initCourseDetails: function () {
            var that = this
            var csid = parseInt(ApiHelper.getQueryString('courseId'))
            $('body').on('realBuyOK', function (e, data) {
                data = data || {}
                var callback = data.callback
                courseId = parseInt(courseId)
                if (ApiHelper.idxInArr(that.data.realCourses, courseId) !== -1 || ApiHelper.idxInArr(that.data.doubleCourses, courseId) !== -1) {
                    location.href = ApiHelper.getActUrl() + '/addr?id=' + courseId + '&type=4'
                    return
                }
                callback && callback()
            })
            // 实物课程，双购课程
            if (ApiHelper.idxInArr(that.data.realCourses, csid) === -1 && ApiHelper.idxInArr(that.data.doubleCourses, csid) === -1) {
                return
            }
            that.forbidfShare()
            $('body').on('realGoodsInfo', function (e, data) {
                that.forbidfShare()
                that._initCourseDetails(data.realGoodsInfo || {})
            })
        },
        _initCourseDetails: function (data) {
            var that = this
            // 回到顶部按钮
            $('.toTopBtn').css({
                top: '65%'
            })
            $('.runTip').hide()
            // 已购买视频
            var csid = parseInt(ApiHelper.getQueryString('courseId'))
            that.data.totalTime = data.countDownTimeMills
            var priceIdx = 0
            if (ApiHelper.idxInArr(that.data.realCourses, csid) > -1) {
                $('body').append(csDetailRealBtn)
                priceIdx = 0
            } else {
                $('body').append(csDetailBtn)
                priceIdx = 1
                $('#csDetailBtn .tip').attr('src', that.imgPath + 'add_buy.png?v=' + ApiHelper.myVer)
                $('#csDetailBtn .icon').attr('src', that.imgPath + 'hand.png?v=' + ApiHelper.myVer)
            }
            // 单购视频价格
            this.data.onlyVideoCourseId = data.onlyVideoCourseId
            $('#csDetailBtn .buy-video .price').text('￥' + ApiHelper.floorPrice(data.onlyVideoPrice / 100))

            $('#csDetailBtn .buy-video').click(function () {
                // 二次弹窗已弹过
                if (ApiHelper.getCookie(that.data.realBuyCfm)) {
                    that.realBuyVideo() // 购买视频
                    return
                }
                // pvuv
                ApiHelper.addPvuv({
                    btn: that.pvuvKey['11']
                })
                ApiHelper.setCookie(that.data.realBuyCfm, 1, 7)
                $('.swiper-wrapper').hide()
                $('#cfmBuyDia').css({
                    display: 'flex'
                })
            })
            $('.pay_btn_box').hide()
            // 倒计时卡片
            $('.course_details #limitPic').hide()
            $('.course_details .intro_box').show()
            $('.course_details .explainText').hide()
            $('.course_details .on_sale_box').remove()
            $('.tab_box #participateIn').remove()
            $(csDetailDjsCon).insertAfter($('#course_des'))
            // 更新价格
            $('#csDetailDjsCon .l .num').text(that.data.nowPriceArr[priceIdx])
            $('#csDetailDjsCon .r .old').text(that.data.oldPriceArr[priceIdx])
            $('.csdetail-djscon').css({
                backgroundImage: 'url("' + that.imgPath + '/cs-card-back.png?v=' + ApiHelper.myVer + '")'
            })
            // 开始倒计时
            that.startTimeDown()

            $('body').append(cfmBuyDia)
            $('#cfmBuyDia .icon').attr('src', that.imgPath + 'cfm_d.png?v=' + ApiHelper.myVer)
            $('#cfmBuyDia .jg-btn').css({
                backgroundImage: 'url("' + that.imgPath + 'jiag_btn.png?v=' + ApiHelper.myVer + '")'
            })
            // 加购
            $('#csDetailRealBtn .buy-real').click(function () {
                that.realBuy()
            })
            // 双购事件
            $('#csDetailBtn .buy-real').click(function () {
                courseId = parseInt(ApiHelper.getQueryString('courseId'))
                that.realBuyAll()
                $('#cfmBuyDia').hide()
            })
            $('#cfmBuyDia .jg-btn').click(function () {
                // pvuv
                ApiHelper.addPvuv({
                    btn: that.pvuvKey['12']
                })
                that.realBuyAll()
                $('.swiper-wrapper').show()
                $('#cfmBuyDia').hide()
            })
            $('#cfmBuyDia .yid-back').click(function () {
                $('#cfmBuyDia').hide()
                $('.swiper-wrapper').show()
                that.realBuyVideo()
            })
        },
        // 购买视频
        realBuyVideo: function () {
            courseId = this.data.onlyVideoCourseId
            this.realBuy()
        },
        // 加购实物
        realBuy: function () {
            $('body').data('no_pay_box', 1)
            $('.pay_alone_btn').trigger('click')
            $('.sure_pay').trigger('click')
            $('.alert_bg').hide()
            $('.pay_box').hide().removeClass('open')
            setTimeout(function () {
                $('body').css({
                    'position': 'initial',
                    'height': 'auto'
                })
                $('.alert_bg').hide()
                $('.pay_box').hide().removeClass('open')
                $('.sure_pay').removeAttr('disabled')
            }, 1000)
        },
        // 双购
        realBuyAll: function () {
            this.realBuy()
        },
        // 商城首页
        initMoreCourse: function () {
            var that = this
            $('body').on('notification', function (e, options) {
                var data = (options || {}).data
                var callback = (options || {}).callback
                var cacheKey = '' // 弹窗cookie键值
                var hasRealNotic = false
                data && data.forEach(function (one) {
                    if (one.notificationType === 4) {
                        hasRealNotic = true
                        that.data.relatedId = one.relatedId
                        that.data.totalTime = one.countDownTimeMills
                        that.data.realThingDia = one.cacheKey
                        cacheKey = one.cacheKey
                    }
                })
                // 只弹一次
                if (ApiHelper.getCookie(cacheKey) || !hasRealNotic) {
                    callback && callback()
                    return
                }
                that._initMoreCourse()
            })
        },
        _initMoreCourse: function () {
            var that = this
            ApiHelper.setCookie(this.data.realThingDia, 1, 7)

            $('body').append(addBuyDia)
            var hasBuy = ApiHelper.idxInArr(that.data.realCourses, this.data.relatedId) > -1
            this.data.buyType = hasBuy

            var backImg = this.data.buyType ? 'jiagou_d.png?v=' : 'shuanggou_d.png?v='
            // pvuv
            ApiHelper.addPvuv({
                btn: that.data.buyType ? that.pvuvKey['1'] : that.pvuvKey['4']
            })
            $('#addBuyDia .yid-con-body').css({
                width: this.data.buyType ? '6.24rem' : '6.53rem',
                backgroundImage: 'url("' + that.imgPath + backImg + ApiHelper.myVer + '")'
            })
            $('#addBuyDia .xsq-btn').css({
                backgroundImage: 'url("' + that.imgPath + 'xiansq.png?v=' + ApiHelper.myVer + '")'
            })
            $('#addBuyDia .yid-cls-con').click(function () {
                // pvuv
                ApiHelper.addPvuv({
                    btn: that.data.buyType ? that.pvuvKey['2'] : that.pvuvKey['5']
                })
                that.hideAddBuyDia()
            })
            $('#addBuyDia .yid-con-body').click(function () {
                that.hideAddBuyDia()
                // pvuv
                ApiHelper.addPvuv({
                    btn: that.data.buyType ? that.pvuvKey['3'] : that.pvuvKey['6']
                }, function () {
                    that.goCourseDetail(that.data.buyType ? 20070 : 20071)
                })
            })
            $('.yidialog-con .yid-cls').attr('src', that.imgPath + 'close_bs.png?v=' + ApiHelper.myVer)
            // 开始倒计时
            this.startTimeDown()
        },
        // 课程详情
        goCourseDetail: function (options) {
            var data = options || {}
            var channel = data.channel || ''
            var that = this
            var csid = that.data.relatedId
            location.href = '/wx/groupBuy/courseDetails.html?posterOpenId=natureSubPoster&courseId=' + csid + '&state=' + channel
        },
        // 半价倒计时
        startTimeDown: function () {
            new NewTimer(this.data.totalTime, function (timeData) {
                var timeArr = timeData.slice(1)
                $('#csDetailDjsCon .djs').text(timeArr.join(':'))
                $('.djs-con').show().text('半价抢倒计时 ' + timeArr.join(':'))
            }, function () {
                $('#csDetailDjsCon .djs').text('0:0:0:0')
                $('.djs-con').hide()
            }, 10).startCountDown()
        },
        hideAddBuyDia: function () {
            $('#addBuyDia').hide()
        }
    }
</script>

<style scoped lang="less">
    .flex-row {
        display: -moz-box;
        /* 老版本语法: Firefox (buggy) */
        display: -ms-flexbox;
        /* 混合版本语法: IE 10 */
        display: -webkit-flex;
        /* 新版本语法: Chrome 21+ */
        display: flex;
    }

    @cl-mask: rgba(0, 0, 0, 0.85);
    /**弹窗**/
    .yidialog-con {
        position: fixed;
        width: 100%;
        height: 100%;
        top: 0px;
        left: 0px;
        display: flex;
        align-items: center;
        justify-content: center;
        z-index: 1000;

        .yid-back {
            position: absolute;
            left: 0px;
            top: 0px;
            width: 100%;
            height: 100%;
            text-align: center;
            background: @cl-mask;
        }

        .yid-con {
            position: relative;
            display: flex;
            justify-content: center;
            align-content: center;
            color: #ffffff;
            flex-wrap: wrap;

            .yid-cls {
                position: relative;
                z-index: 9999;
                width: 0.51rem;
                height: 0.51rem;
                flex-shrink: 0;
            }

            .yid-hand {
                position: absolute;
                width: 1rem;
                top: 3.1rem;
                right: 0.1rem;
                animation: handClick 1s infinite;
            }
        }

        .yid-con-col {
            flex-direction: column;
        }
    }

    /**加购弹窗**/
    .real-thing-dia {
        .yid-con {
            flex-direction: column;

            .yid-cls-con {
                align-self: flex-end;
                margin-right: unset;
            }

            .yid-con-body {
                width: 624px;
                height: 779px;
                margin-top: 30px;
                border-radius: 10px;
                flex-direction: column;
                position: relative;
                background-repeat: no-repeat;
                background-size: 100% 100%;

                .xsq-btn {
                    width: 347px;
                    height: 119px;
                    justify-content: center;
                    align-items: center;
                    color: #ffffff;
                    border-radius: 10px;
                    align-self: center;
                    margin-top: 579px;
                    background-repeat: no-repeat;
                    background-size: 100% 100%;
                }

                .djs-con {
                    color: #4a55ce;
                    font-size: 31px;
                    margin-top: 19px;
                    align-self: center;
                }
            }
        }
    }

    /**二次确认蒙层**/
    .real-thing-cfmdia {
        display: none;
        background-repeat: no-repeat;
        background-size: 100% 100%;

        .yid-con {
            .yid-con-body {
                .icon {
                    width: 622px;
                    height: 490px;
                }

                .jg-btn {
                    background-repeat: no-repeat;
                    background-size: 100%;
                    color: #ffffff;
                    width: 347px;
                    height: 119px;
                    margin-top: 18px;
                    margin-left: 295px;
                    justify-content: center;
                    align-items: center;
                }
            }
        }
    }

    /**购买详情页倒计时卡片**/
    .csdetail-djscon {
        align-items: center;
        height: 110px;
        justify-content: center;
        background-size: 100%;
        background-repeat: no-repeat;

        .djs-l {
            flex-grow: 1;
            justify-content: center;
            text-align: center;
            align-items: center;
            color: #ffffff;

            .l {
                margin-left: 18px;
                font-size: 60px;
                display: flex;
                align-items: center;
                font-weight: bold;

                .bi {
                    font-size: 40px;
                    align-self: flex-end;
                    margin-bottom: 6px;
                }
            }

            .r {
                flex-grow: 2;
                display: flex;
                flex-direction: column;
                font-size: 24px;
                align-items: flex-start;
                margin-left: 23px;

                .r-con {
                    display: flex;
                    flex-direction: column;
                    align-items: center;

                    .old-p {
                        display: flex;
                        align-items: center;

                        .old {
                            text-decoration: line-through;
                        }
                    }

                    .badge {
                        margin-top: 7px;
                        border-radius: 10px;
                        color: #ff2741;
                        font-weight: bold;
                        background-color: #ffffff;
                        padding: 6px 18px;
                    }
                }
            }
        }

        .djs-r {
            width: 260px;
            color: #ffffff;
            text-align: center;

            .djs {
                margin-top: 14px;
            }
        }
    }

    /**购买详情购买按钮**/
    .csdetail-buybtn {
        position: fixed;
        bottom: 40px;
        left: 30px;
        right: 30px;
        display: flex;
        font-size: 27px;
        color: #FFFFFF;
        justify-content: center;
        height: 96px;
        border-radius: 48px;

        .buy-video, .buy-real {
            width: 285px;
            height: 96px;
            background-color: #ffb000;
            border-radius: 48px;
            text-align: center;
            font-size: 36px;
            flex-direction: column;
            justify-content: center;

            .price {
                font-weight: bold;
            }

            .label {
                margin-top: 2px;
                font-size: 28px;
            }
        }

        .buy-real {
            flex-grow: 1;
            margin-left: 35px;
            background-color: #ff4e00;
            border-radius: 48px;
        }

        .hand-con {
            position: absolute;
            right: 0px;
            bottom: 124px;
            flex-direction: column;

            .tip {
                width: 213px;
                height: 83px;
            }

            .icon {
                width: 43px;
                height: 58px;
                margin-left: 112px;
                margin-top: 5px;
            }
        }
    }

    .csdetail-buyreal {
        background-color: #ff4e00;

        .buy-real {
            border-radius: 48px;
            display: flex;
            align-items: center;
            justify-content: center;
            margin-left: 0;

            .price {
                margin-top: 0;
            }

            .label {
                margin-left: 10px;
                margin-top: 0;
                font-weight: bold;
            }
        }
    }

    /**课程目录页卡片**/
    .sectionList-con {
        width: 750px;
        height: 280px;
        background-size: 100%;
        background-repeat: no-repeat;

        .icon {
            width: 335px;
            height: 69px;
            margin-top: 167px;
            margin-left: 354px;
        }
    }

    /**课程播放页浮标**/
    .sectionList-icon {
        position: fixed;
        right: 0px;
        top: 50%;
        z-index: 999;

        .icon {
            width: 196px;
            height: 220px;
        }
    }

    .icon-click {
        animation: iconClick 1s infinite;
    }

    @keyframes iconClick {
        0%, 100% {
            margin-bottotm: 0;
        }
        50% {
            margin-bottom: -35px;
            transform: scale(1.1);
        }
    }

    @keyframes handClick {
        from {
            margin-top: 0rem;
            margin-right: 0rem;
        }
        50% {
            margin-top: -0.1rem;
            margin-right: 0.1rem;
            transform: scale(0.9);
        }
        to {
            margin-top: -0rem;
            margin-right: 0rem;
        }
    }

    .scale-size {
        animation: scaleSize 2s infinite;
    }

    @keyframes scaleSize {
        from {
            transform: scale(0.9);
            opacity: 0.9;
        }
        50% {
            transform: scale(1.2);
            opacity: 1;
        }
        to {
            transform: scale(0.9);
            opacity: 0.9;
        }
    }

    .heart-beat {
        animation: heartBeat 1s infinite;
    }

    @keyframes heartBeat {
        0% {
            -webkit-transform: scale(1);
            transform: scale(1);
        }

        14% {
            -webkit-transform: scale(.8);
            transform: scale(.8);
        }

        28% {
            -webkit-transform: scale(1);
            transform: scale(1);
        }

        42% {
            -webkit-transform: scale(.8);
            transform: scale(.8);
        }

        70% {
            -webkit-transform: scale(1);
            transform: scale(1);
        }
    }

    /**淡入*/
    .fade-in {
        animation: fadeIn 1s;
    }

    @keyframes fadeIn {
        from {
            opacity: 0;
        }
        to {
            opacity: 1;
        }
    }
</style>
